<!-- 
	jGrouseDoc template file. 
	Creates content for top-left frame with all namespaces
	@Copyright (c) 2007 by Denis Riabtchik. All rights reserved. See license.txt and http://jgrouse.com for details@
	$Id: allLogicalContainers.xslt 249 2007-11-12 00:51:31Z denis.riabtchik $
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	version="1.0">
	<xsl:param name='rootPath' />
	<xsl:param name='version'/>	
    <xsl:param name='aux_css'>not_specified</xsl:param>
	
	<xsl:output method='HTML' doctype-public="-//W3C//DTD HTML 4.01//EN"
		doctype-system="http://www.w3.org/TR/html4/strict.dtd">

	</xsl:output>
    <xsl:import href="../../common/xslt/common.xslt"/>

	<xsl:template match="/">
		<xsl:comment>Generated by jGrouseDoc</xsl:comment>
		<html>
		    <head>
			     <xsl:call-template name="writeCss">
			         <xsl:with-param name="rootPath"><xsl:value-of select="$rootPath"/></xsl:with-param>
			         <xsl:with-param name="aux_css"><xsl:value-of select="$aux_css"/></xsl:with-param>
			     </xsl:call-template>
			</head>
			<body>
			    <div class="allLogicalContainers">
		        <div class="overviewSwitch">
                    <span>
                    <a href="overview-frame.html">Files</a>
                    </span>
                </div>
			    <div class="allnamespaces">
			         <a href="allclasses-frame.html" target="packageFrame">All Top-Level Elements</a>
			    </div>
			
				<div class="overviewSectionHeader">Namespaces</div>
				<xsl:for-each select="/jgdoc/items/namespace">
					<xsl:sort select="@id"/>
					<div class="logicalSummaryItem">
						<xsl:element name="a">
							<xsl:attribute name="href">logical/<xsl:value-of select="@path"/>-summary.html</xsl:attribute>
							<xsl:attribute name="target">packageFrame</xsl:attribute>
							<div class="objName"><xsl:value-of select="comment/name"/></div>
						</xsl:element>
					</div>
				</xsl:for-each>
				</div>	
			</body>
		</html>
	</xsl:template>



</xsl:stylesheet>
