<!-- 
	jGrouseDoc template file. 
	Creates content for top-left frame with all files and modules
	@Copyright (c) 2007 by Denis Riabtchik. All rights reserved. See license.txt and http://jgrouse.com for details@
	$Id: allPhysContainers.xslt 249 2007-11-12 00:51:31Z denis.riabtchik $
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	version="1.0">
	<xsl:param name='rootPath' />
	<xsl:param name='version'/>	
    <xsl:param name='aux_css'>not_specified</xsl:param>
	
	<xsl:output method='HTML' doctype-public="-//W3C//DTD HTML 4.01//EN"
		doctype-system="http://www.w3.org/TR/html4/strict.dtd">

	</xsl:output>

	<xsl:template match="/">
		<xsl:comment>Generated by jGrouseDoc</xsl:comment>
		<html>
		    <head>
			<xsl:element name="link">
				<xsl:attribute name="rel">stylesheet</xsl:attribute>
				<xsl:attribute name="type">text/css</xsl:attribute>
				<xsl:attribute name="href"><xsl:value-of select="$rootPath"/>jgdoc.css</xsl:attribute>
			</xsl:element>
            <xsl:element name="link">
                <xsl:attribute name="rel">stylesheet</xsl:attribute>
                <xsl:attribute name="type">text/css</xsl:attribute>
                <xsl:attribute name="href"><xsl:value-of select="$rootPath"/>theme.css</xsl:attribute>
            </xsl:element>
			
            <xsl:if test="$aux_css != 'not_specified'">
                <xsl:element name="link">
                    <xsl:attribute name="rel">stylesheet</xsl:attribute>
                    <xsl:attribute name="type">text/css</xsl:attribute>
                    <xsl:attribute name="href"><xsl:value-of select="$rootPath"/><xsl:value-of select="$aux_css"/></xsl:attribute>
                </xsl:element>
            </xsl:if>
			</head>
			<body>
			     <div class="allPhysContainers">
			     <div class="overviewSwitch">
                    <span>
                    <a href="overview-frame-log.html">Namespaces</a>
                    </span>
                </div>
			
				<div>
                     <a href="allclasses-frame.html" target="packageFrame">All Top-Level Elements</a>
                </div>
			
				<div class="overviewSectionHeader">Files</div>
				<xsl:for-each select="/jgdoc/items/file[@isModuleFile='false']">
					<xsl:sort select="@id"/>
					<div>
						<xsl:element name="a">
							<xsl:attribute name="href">physical/<xsl:value-of select="@path"/>-summary.html</xsl:attribute>
							<xsl:attribute name="target">packageFrame</xsl:attribute>
							<xsl:value-of select="comment/name"/>
						</xsl:element>
					</div>
				</xsl:for-each>	
				<br/>
				<div class="overviewSectionHeader">Modules</div>
				<xsl:for-each select="/jgdoc/items/module">
					<xsl:sort select="@id"/>
					<div class="physicalSummaryItem">
						<xsl:element name="a">
							<xsl:attribute name="href">physical/<xsl:value-of select="@path"/>-summary.html</xsl:attribute>
							<xsl:attribute name="target">packageFrame</xsl:attribute>
							<xsl:value-of select="comment/name"/>
						</xsl:element>
					</div>
				</xsl:for-each>
				</div>	
			</body>
		</html>
	</xsl:template>



</xsl:stylesheet>
