<!-- 
	jGrouseDoc template file. Renders overview of all physical containers. Shown in main frame
	@Copyright (c) 2007 by Denis Riabtchik. All rights reserved. See license.txt and http://jgrouse.com for details@
	$Id: physContainersListMain.xslt 249 2007-11-12 00:51:31Z denis.riabtchik $
-->

<!-- 
	Renders "content page" with list of all files and modules
 -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	version="1.0">
	<xsl:param name='rootPath' />
	<xsl:param name="projectDesc"/>
	<xsl:param name='version'/>	
    <xsl:param name='aux_css'>not_specified</xsl:param>
	
	<xsl:output method='HTML' doctype-public="-//W3C//DTD HTML 4.01//EN"
		doctype-system="http://www.w3.org/TR/html4/strict.dtd">
	</xsl:output>
	<xsl:import href="../../common/xslt/common.xslt"/>
	
	<xsl:template match="/">
		<xsl:comment>Generated by jGrouseDoc</xsl:comment>
	
		<html>
		    <head>
                <xsl:call-template name="writeCss">
                     <xsl:with-param name="rootPath"><xsl:value-of select="$rootPath"/></xsl:with-param>
                     <xsl:with-param name="aux_css"><xsl:value-of select="$aux_css"/></xsl:with-param>
                 </xsl:call-template>
			</head>
			<body>
                <div class="physicalSummary">
                <xsl:call-template name="navbarPhys">
                    <xsl:with-param name="isStartup">yes</xsl:with-param>
                </xsl:call-template> 
                <br/>               
				<H1><xsl:value-of select="$projectDesc"/></H1>		
				<br/>
				<xsl:if test="count(/jgdoc/project) != 0">
				    <div class="projectDescRef">
                        <a href="#desc">Project Description</a>
                    </div>
                </xsl:if>
				<xsl:if test="count(/jgdoc/items/file[@isModuleFile='false']) != 0">
                    <div class="summaryTable">
                        <div class="summaryTableHeader">
								Files
						</div>
						<xsl:for-each select="/jgdoc/items/file[@isModuleFile='false']">
							<xsl:sort select="@id"/>
                            <div class="summaryItem">
                                <div class="summaryItemDef">
									<xsl:element name="a">
										<xsl:attribute name="href">physical/<xsl:value-of select="@path"/>.html</xsl:attribute>
										<xsl:value-of select="comment/name"/>
									</xsl:element>
								</div>
                                <div class="summaryItemDesc">
									<xsl:value-of select="comment/summary"/><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								</div>
							</div>
						</xsl:for-each>	
					</div>
					<br/>
				</xsl:if>
				<xsl:if test="count(/jgdoc/items/module) != 0">
					<div class="summaryTable">
						<div class="summaryTableHeader">
							Modules
						</div>
						<xsl:for-each select="/jgdoc/items/module">
							<xsl:sort select="@id"/>
							<div class="summaryItem">
								<div class="summaryItemDef">
									<xsl:element name="a">
										<xsl:attribute name="href">physical/<xsl:value-of select="@path"/>.html</xsl:attribute>
										<xsl:value-of select="comment/name"/>
									</xsl:element>
								</div>
								<div class="summaryItemDesc">
									<xsl:value-of select="comment/summary"/><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								</div>
							</div>
						</xsl:for-each>	
					</div>
					<br/>
				</xsl:if>
                <xsl:if test="count(/jgdoc/project) != 0">
                    <a name="desc"></a><br/>
                    <xsl:apply-templates select='/jgdoc/project/comment/commentContent/content'/>
                    <p />
                    <xsl:apply-templates select="/jgdoc/project/comment" mode="genCommonAttrs" />
                </xsl:if>
                </div>				
			</body>
		</html>
	</xsl:template>



</xsl:stylesheet>
