<!-- 
	jGrouseDoc template file. Creates Index page.
	Based on contribution from broofa (http://broofa.com)
	@Copyright (c) 2007 by Denis Riabtchik. All rights reserved. See license.txt and http://jgrouse.com for details@
	$Id: trueindex.xslt 249 2007-11-12 00:51:31Z denis.riabtchik $
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0">
    <xsl:param name='rootPath' />
    <xsl:param name="projectDesc"/>
    <xsl:param name='version'/>
    <xsl:param name='aux_css'>not_specified</xsl:param>
    
    <xsl:output method='HTML' doctype-public="-//W3C//DTD HTML 4.01//EN"
        doctype-system="http://www.w3.org/TR/html4/strict.dtd">

    </xsl:output>
    <xsl:import href="../../common/xslt/common.xslt"/>
    
    <xsl:template match="/">
        <xsl:comment>Generated by jGrouseDoc</xsl:comment>
    
        <html>
            <head>
                <xsl:call-template name="writeCss">
                     <xsl:with-param name="rootPath"><xsl:value-of select="$rootPath"/></xsl:with-param>
                     <xsl:with-param name="aux_css"><xsl:value-of select="$aux_css"/></xsl:with-param>
                 </xsl:call-template>
                <xsl:element name="link">
                    <xsl:attribute name="rel">stylesheet</xsl:attribute>
                    <xsl:attribute name="type">text/css</xsl:attribute>
                    <xsl:attribute name="href"><xsl:value-of select="$rootPath"/>jgindex.css</xsl:attribute>
                </xsl:element>
                 
            <script type="text/javascript" src="jgindex.js">
            </script>
            </head>
            <body>
                <div class="index">
				<h1>Index</h1>
				<div id="toc"></div>
				<p>Classes, structs, objects and interfaces are shown in bold</p>
				<div id="index">Loading...</div>
				<div id="jgsInfo" class="jgsInfo" style="display:none"></div>
				</div>
			</body>
            <script type="text/javascript" src="jsindex.js">
            </script>
        </html>
    </xsl:template>
</xsl:stylesheet>
