<!-- 
	jGrouseDoc template file. 
	Creates content for top-left frame with all files and modules
	@Copyright (c) 2007 by Denis Riabtchik. All rights reserved. See license.txt and http://jgrouse.com for details@
	$Id: allFiles.xslt 259 2007-11-12 03:15:58Z denis.riabtchik $
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	version="1.0">
	<xsl:param name='rootPath' />
	<xsl:param name='version'/>	
    <xsl:param name='aux_css'>not_specified</xsl:param>
	
	<xsl:output method='HTML' doctype-public="-//W3C//DTD HTML 4.01//EN"
		doctype-system="http://www.w3.org/TR/html4/strict.dtd">

	</xsl:output>
    <xsl:import href="../../common/xslt/common.xslt"/>

	<xsl:template match="/">
		<xsl:comment>Generated by jGrouseDoc</xsl:comment>
		<html>
		    <head>
                 <xsl:call-template name="writeCss">
                     <xsl:with-param name="rootPath"><xsl:value-of select="$rootPath"/></xsl:with-param>
                     <xsl:with-param name="aux_css"><xsl:value-of select="$aux_css"/></xsl:with-param>
                 </xsl:call-template>
			</head>
			<body>
			    <div class="allPhysContainers"> 
			    <div class="navbar">
                    Browse by 
                    <a href="allclasses-frame.html">name</a> &#183;
                    <a href="navtree.html">path</a> &#183; 
                    <span class="currentPage">file</span>
                </div>
				<div class="overviewSectionHeader">Files</div>
				<xsl:for-each select="/jgdoc/items/file[@isModuleFile='false']">
					<xsl:sort select="@id"/>
					<div>
						<xsl:element name="a">
							<xsl:attribute name="href">physical/<xsl:value-of select="@path"/>.html</xsl:attribute>
							<xsl:attribute name="target">classFrame</xsl:attribute>
							<xsl:value-of select="comment/name"/>
						</xsl:element>
					</div>
				</xsl:for-each>	
				<br/>
				<div class="overviewSectionHeader">Modules</div>
				<xsl:for-each select="/jgdoc/items/module">
					<xsl:sort select="@id"/>
					<div>
						<xsl:element name="a">
							<xsl:attribute name="href">physical/<xsl:value-of select="@path"/>.html</xsl:attribute>
							<xsl:attribute name="target">classFrame</xsl:attribute>
							<xsl:value-of select="comment/name"/>
						</xsl:element>
					</div>
				</xsl:for-each>	
				</div>
			</body>
		</html>
	</xsl:template>



</xsl:stylesheet>
