<!-- 
    jGrouseDoc template file. Renders overview of all logical containers (classes, namespaces, etc)
        - shown in main frame
    @Copyright (c) 2007 by Denis Riabtchik. All rights reserved. See license.txt and http://jgrouse.com for details@
    $Id: mainpage.xslt 249 2007-11-12 00:51:31Z denis.riabtchik $
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0">
    <xsl:param name='rootPath' />
    <xsl:param name="projectDesc"/>
    <xsl:param name='version'/>
    <xsl:param name='aux_css'>not_specified</xsl:param>
    
    <xsl:output method='HTML' doctype-public="-//W3C//DTD HTML 4.01//EN"
        doctype-system="http://www.w3.org/TR/html4/strict.dtd">

    </xsl:output>
    <xsl:import href="../../common/xslt/common.xslt"/>
    
    <xsl:template match="/">
        <xsl:comment>Generated by jGrouseDoc</xsl:comment>
    
        <html>
            <head>
                 <xsl:call-template name="writeCss">
                     <xsl:with-param name="rootPath"><xsl:value-of select="$rootPath"/></xsl:with-param>
                     <xsl:with-param name="aux_css"><xsl:value-of select="$aux_css"/></xsl:with-param>
                 </xsl:call-template>
            </head>
            <body>
                <div class="logicalSummary">
                <xsl:call-template name="navbarLog"/>
                <br/>
                <H1><xsl:value-of select="$projectDesc"/></H1>          
                <br/>
                <xsl:if test="count(/jgdoc/project) != 0">
                    <div class="projectDescRef">
                        <a href="#desc">Project Description</a>
                    </div>
                </xsl:if>
                <xsl:if test="count(/jgdoc/project) != 0">
                    <div class="projectDesc">
                    <a name="desc"></a><br/>
                    <xsl:apply-templates select='/jgdoc/project/comment/commentContent/content'/>
                    <p />
                    <xsl:apply-templates select="/jgdoc/project/comment" mode="genCommonAttrs" />
                    </div>
                </xsl:if>
                </div>
            </body>
        </html>
    </xsl:template>



</xsl:stylesheet>
